#ifndef SIEGENERATOR_H
#define SIEGENERATOR_H
//----------------------------------------------------------
#include "sieobject.h"
//----------------------------------------------------------
struct sieTransact;
struct sieTransactList;
//----------------------------------------------------------

class sieGenerator : public sieObject
{
	Q_OBJECT
public:
	sieGenerator(QObject* parent,const char* name,sieTransactList* trList,
		     int tgen,int disp,int num);
	~sieGenerator();
	virtual void tic(int time=0);
	virtual void tic0(int time=0);
	virtual bool isReady() {return false;}
	virtual void init();
	virtual bool interchange(sieTransact* tr);
	bool sendTransact(sieTransact* tr);
	int generationNumber() {return genNumInit;}
	int transactType();
	int generationTime() {return delayTime;}
	int dispersion() {return dispTime;}
	
	int lifeLimit();
	int lifeLimitDisp() {return transactLifeLimitDisp;}
	double cost();
	double costDisp() {return transactCostDisp;};
	
	void setGenerationNumber(int k) {genNumInit=k;}
	void setGenerationType(int k);
	void setGenerationTime(int k) {delayTime=k;}
	void setDispersion(int k) {dispTime=k;}
	
	sieTransact* transactProperty() {return transact;}
	void setTransactProperty(sieTransact* tr,int trLLD,double trCD);
	signals:
//	void signalNewTransact();
	void signalGeneratorEmpty();
	
//public slots:
//	virtual void slotReceive(sieTransact* tr);
private:
	int genNum;
	int genNumInit;
//	int genType;
	int tdel;
	sieTransactList* transactList;
	int delayTime;
	int dispTime;
//	int transactLifeLimit;
	int transactLifeLimitDisp;
//	double transactCost;
	double transactCostDisp;
};

//----------------------------------------------------------

#endif
