#include "sieobject.h"
//----------------------------------------------------------
#include "sietypes.h"
#include "sietransact.h"
//----------------------------------------------------------

sieObject::sieObject(QObject* parent,const char* name,int tp) : QObject(parent,name),
			transact(0),objecttype(tp),
			currentTime(0),
			statTransactNum(0),statBusyTime(0),statFreeTime(0),
			statAge(0),statTransactMaxNum(0),destinations(0),sources(0),
			X(0),Y(0),guiObj(0),initGuiObject(0)
{
	qDebug("%s: sieObject::type=%d",name,tp);
	
//	QString str=QString("%1: sieObject").arg(name);
//	emit signalSendStatistic(str);

}

//----------------------------------------------------------

sieObject::~sieObject()
{
//	qDebug("%s: ~sieObject::",name());
	if(transact) 
	{
		qDebug("~transact");
//		delete transact;
	}
	
	ObjectsList* d,*p=destinations;
	while(p)
	{
		d=p;
		p=p->next;
		delete d;
	}

	p=sources;
	while(p)
	{
		d=p;
		p=p->next;
		delete d;
	}
//	QString str=QString("%1: ~sieObject").arg(name());
//	emit signalSendStatistic(str);

}

void sieObject::setGui(GuiObject* obj)
{
//	qDebug("setGui = %ld",obj);
	initGuiObject=obj;
//	qDebug("%s: setGui = %ld",name(),guiObj);
}

void sieObject::setVisual(bool isVis)
{
	if(isVis)
		guiObj=initGuiObject;
	else
		guiObj=0;
}


void sieObject::init()
{
//	qDebug("init %s",name());
}
//----------------------------------------------------------
bool sieObject::interchange(sieTransact* tr)
{
	tr=tr;
	qFatal("%s: function \"interchange\" must be reimplemented",name());
	return false;
}

//----------------------------------------------------------

void sieObject::tic0(int time)
{
	currentTime=time;
//	qDebug("%s: Gui = %ld",name(),guiObj);
}


//----------------------------------------------------------

void sieObject::getStatistic(sieStatistic* stat)
{
	stat->transNum=statTransactNum;
	if(statBusyTime*statFreeTime!=0)
	{
		
		stat->objectCapacity=static_cast<double>(statBusyTime)*100./static_cast<double>(statBusyTime+statFreeTime);
		
	}
	else
		stat->objectCapacity=-1;
	if(statAge!=0)
	{
		stat->transAverageAge=static_cast<double>(statAge)/static_cast<double>(statTransactNum);
	}
	else
		stat->transAverageAge=-1;
	
	if(statTransactMaxNum!=0)
	{
		stat->transMaxNum=statTransactMaxNum;
	}
	else
		stat->transMaxNum=-1;
	
	if(statSumCost>0.0)
	{
		stat->sumCost=statSumCost;
	}
	else
		stat->sumCost=-1.;
}

//----------------------------------------------------------

void sieObject::clearStatistic()
{
	statTransactNum=0;
	statBusyTime=0;
	statFreeTime=0;
	statAge=0;
	statTransactMaxNum=0;
	currentTime=0;
	statSumCost=0;
}

//----------------------------------------------------------

void sieObject::addDestination(sieObject* obj,int type,int probability)
{
	ObjectsList* p=destinations;
	if(p)
	{
		while(p->next) p=p->next;
		p->next=new ObjectsList;
		p=p->next;
		p->obj=obj;
		p->type=type;
		p->probability=probability;
		p->next=0;
	}
	else
	{
		destinations=new ObjectsList;
		destinations->obj=obj;
		destinations->type=type;
		destinations->probability=probability;
		destinations->next=0;
	}
}

//----------------------------------------------------------
void sieObject::addSource(sieObject* obj,int tp)
{
	ObjectsList* p=sources;
	if(p)
	{
		while(p->next) p=p->next;
		p->next=new ObjectsList;
		p=p->next;
		//strncpy(p->name,objName,NAMESIZE);
		p->obj=obj;
		p->type=tp;
		p->next=0;
	}
	else
	{
		sources=new ObjectsList;
		//strncpy(sources->name,objName,NAMESIZE);
		sources->obj=obj;
		sources->type=tp;
		sources->next=0;
	}
}

/*
void sieObject::slotChangeReceiverStatus(bool ready)
{
//	qDebug("%s: Receiver change status %d",name());
	isReceiverReady=ready;
}
*/
//----------------------------------------------------------
//----------------------------------------------------------
