#include <qtextedit.h>
#include "siepacker.h"
//----------------------------------------------------------
#include "sietransact.h"
#include "sietransactlist.h"
#include "guiobject.h"
//----------------------------------------------------------

siePacker::siePacker(QObject* parent,const char* name,sieTransactList* trList,int tp) :
 				sieObject(parent,name,SIE_PACKER),transactList(trList),type(tp)
{
	
}

//----------------------------------------------------------
siePacker::~siePacker()
{
//	qDebug("%s: ~siePacker",name());
}


void siePacker::init()
{
//	qDebug("init %s",name());
	ObjectsList* ps=sources;
	while(ps)
	{
		ps->already=false;
		ps=ps->next;
	}
}

//----------------------------------------------------------

void siePacker::tic(int time)
{
	currentTime=time;
	ObjectsList* ps=sources;
	bool fl1=true;
	bool fl2=true;
	while(ps)
	{
		if(ps->already==false) 
		{
			fl1=false;
		}
		else
			fl2=false;
		
		ps=ps->next;
	}
//	qDebug("%s: fl1=%d fl2=%d",name(),fl1,fl2);
	if(fl2)		// 
	{
		statFreeTime++;
		return;
	}
	
	statBusyTime++;
	
	if(fl1)		// 
	{
		transact=transactList->create();
		strncpy(transact->source,name(),NAMESIZE);
		transact->type=type;
		ObjectsList* p=destinations;
		bool fl=false;
		while(p)
		{
			printf("%d    %s: send transact to %s\n",time,name(),p->obj->name());
			output->append(QString("%1    %2  ->  %3").arg(time).arg(name()).arg(p->obj->name()));
			if(p->obj->interchange(transact))
				fl=true;
			p=p->next;
		}
		if(fl) 
		{
			if(guiObj) guiObj->setVisualTransact(0);

			ps=sources;
			while(ps)
			{
				ps->already=false;
				ps=ps->next;
			}
		}
		else
		{
			transactList->remove(transact);
		}
		return;
	}

}

//----------------------------------------------------------

bool siePacker::interchange(sieTransact* tr)
{
	QString str;
	ObjectsList* ps=sources;
	while(ps)
	{
		if(ps->type==tr->type)
		{
			//printf(" type=%d\n",ps->type);
			if(!ps->already)
			{
//				printf(" ok\n");
				ps->already=true;
				printf("%d    %s: receive transact from %s\n",currentTime,name(),tr->source);
				str=QString("%1    %2    %3").arg(currentTime).arg(name()).arg(tr->source);
				
				transactList->remove(tr);
				statTransactNum++;
				
				int num=0;
				ps=sources;
				while(ps)
				{
					if(ps->already) ++num;
					str+=QString(" %1(%2)").arg(ps->type).arg(ps->already);
					ps=ps->next;
				}
				output->append(str);
				
				
				if(guiObj) guiObj->setVisualTransact(num);
				return true;
			}
		}
		ps=ps->next;
	}
	printf("%d    %s: doesn't receive transact\n",currentTime,name());
	str=QString("%1    %2      %3  %4       ").arg(currentTime).arg(name()).arg(tr->type).arg(tr->source);
	ps=sources;
	while(ps)
	{
		str+=QString(" %1(%2)").arg(ps->type).arg(ps->already);
		ps=ps->next;
	}
	output->append(str);
	
	return false;
}
//----------------------------------------------------------

bool siePacker::isReady(int type)
{
	ObjectsList* ps=sources;
	while(ps)
	{
		if(ps->type==type)
		{
			if(!ps->already)
				return true;
		}
		ps=ps->next;
	}
	return false;
}
//----------------------------------------------------------
