#include <qtextedit.h>
#include "siequeue.h"
//----------------------------------------------------------
#include "sietransact.h"
#include "guiobject.h"
//----------------------------------------------------------

sieQueue::sieQueue(QObject* parent,const char* name,int num) : sieObject(parent,name,SIE_QUEUE),
					maxTransactNum(num),currentTransactNum(0)
{
	
}

//----------------------------------------------------------

sieQueue::~sieQueue()
{
//	qDebug("%s: ~sieQueue",name());
}

//----------------------------------------------------------

void sieQueue::tic(int time)
{
	if(transacts.empty()) 
	{
		++statFreeTime;
		return;
	}
	currentTime=time;
	bool fl;		
	sieTransact* tr;
	do
	{
		tr=transacts.front();
		fl=false;
		ObjectsList* ps=sources;
		while(ps)
		{
			if(strncmp(tr->source,name(),NAMESIZE)==0)
			{
				fl=true;
				break;
			}
			else if(strncmp(tr->source,ps->obj->name(),NAMESIZE)==0)
			{
				fl=true;
				break;
			}
			else
				qDebug("%s!=%s",tr->source,ps->obj->name());
			ps=ps->next;
		}
		if(!fl) 
		{
			transacts.pop_front();
			currentTransactNum--;
		}
		if(transacts.empty()) 
		{
			++statFreeTime;
//			qDebug("%s:  empty",name());
			return;
		}
	}
	while(!fl);
	++statBusyTime;
	
	do
	{	
	ObjectsList* p=destinations;
	fl=false;
	while(p)
	{
//		printf("%d    %s: try send transact to %s\n",time,name(),p->obj->name());
		if(!fl) 
		{
			strncpy(tr->source,name(),NAMESIZE);
		}
		if(p->obj->interchange(tr))		//p->obj->isReady(tr->type))
		{
			
			printf("%d    %s: send transact to %s\n",time,name(),p->obj->name());
			//output->append(QString("%1    %2: send transact to %3").arg(time).arg(name()).arg(p->obj->name()));

			//p->obj->interchange(tr);
			fl=true;
		}
		p=p->next;
	}	
	
	if(fl)
	{
		transacts.pop_front();
		currentTransactNum--;
		if(guiObj) guiObj->setVisualTransact(currentTransactNum,true);
		tr=transacts.front();
		if(transacts.empty()) break;
	}


	}
	while(fl);
}
//----------------------------------------------------------

bool sieQueue::interchange(sieTransact* tr)
{
	
	if(currentTransactNum>=maxTransactNum)
	{
		printf("%d    %s     (%d/%d)\n",currentTime,name(),
		       currentTransactNum,maxTransactNum);
		output->append(QString("%1    %2     (%3/%4)").arg(currentTime).arg(name()).arg(currentTransactNum).arg(maxTransactNum));
		return false;
	}
	++statTransactNum;
	++currentTransactNum;
	if(guiObj) guiObj->setVisualTransact(currentTransactNum,true);

	printf("%d    %s receive transact  (%d/%d)\n",currentTime,name(),currentTransactNum,maxTransactNum);
	output->append(QString("%1    %2    (%3/%4)").arg(currentTime).arg(name()).arg(currentTransactNum).arg(maxTransactNum));
	if(statTransactMaxNum<currentTransactNum) statTransactMaxNum=currentTransactNum;
	transacts.push_back(tr);
	return true;
}

//----------------------------------------------------------

void sieQueue::init()
{
	while(!transacts.empty())
		transacts.pop_front();

	currentTransactNum=0;
	if(guiObj) guiObj->setVisualTransact(currentTransactNum,true);
//	qDebug("init %s",name());
}

