#include <qtextedit.h>
#include "sieselector.h"
//----------------------------------------------------------
#include "sietransact.h"
//----------------------------------------------------------

sieSelector::sieSelector(QObject* parent,const char* name,int selType) :
 			sieObject(parent,name,SIE_SELECTOR),selectortype(selType)
{
}

//----------------------------------------------------------

sieSelector::~sieSelector()
{
	qDebug("%s: ~sieSelector",name());
}

//----------------------------------------------------------

void sieSelector::tic(int time)
{
}

//----------------------------------------------------------

bool sieSelector::interchange(sieTransact* tr)
{
	if(selectortype==0)
	{
		int sum=0;
		ObjectsList* p=destinations;
		while(p)
		{
			sum+=p->probability;
			p=p->next;
		}
		int k=rand() % sum;
		p=destinations;
		while(p)
		{
			k-=p->probability;
			if(k<=0) break;
			p=p->next;
		}
		if(p->obj->interchange(tr))
		{
			statTransactNum++;
			return true;
		}
		return false;
		
	}
	else if(selectortype==1)
	{
		if(currentTime-tr->initTime <= tr->lifeLimit)
		{
			ObjectsList* p=destinations;
			while(p)
			{
				if(!p->next) break;
				if(p->obj->interchange(tr))
				{
					statTransactNum++;
					return true;
				}
				p=p->next;
			}
			return false;
		}
		else
		{
			ObjectsList* p=destinations;
			while(true)
			{
				if(!p->next) break;
				p=p->next;
				if(p->obj->interchange(tr))
				{
					statTransactNum++;
					return true;
				}
			}
		}
		return false;
	}
	return false;
}

//----------------------------------------------------------
int sieSelector::destinationNum()
{
	int n=0;
	ObjectsList* p=destinations;
	while(p)
	{
		++n;
		p=p->next;
	}
	return n;
}

//----------------------------------------------------------
int sieSelector::destinationProbability(int k)
{
	ObjectsList* p=destinations;
	while(p)
	{
		if(k<=0) break;
		--k;
		p=p->next;
	}
	return p->probability;
}

//----------------------------------------------------------
void sieSelector::setDestinationProbability(int k,int prob)
{
	ObjectsList* p=destinations;
	while(p)
	{
		if(k<=0) break;
		--k;
		p=p->next;
	}
	if(p) p->probability=prob;
}

//----------------------------------------------------------
const char* sieSelector::destinationName(int k)
{
	ObjectsList* p=destinations;
	while(p)
	{
		if(k<=0) break;
		--k;
		p=p->next;
	}
	return p->obj->name();
}

//----------------------------------------------------------
