#ifndef SIEMODULE_H
#define SIEMODULE_H
//----------------------------------------------------------
#include <qobject.h>
#include <qstring.h>
#include <vector>
//----------------------------------------------------------
#include "sieobject.h"
//----------------------------------------------------------
class QTimer;
class QTextEdit;
class sieTransactList;
//----------------------------------------------------------

class StructModule : public QObject
{
	Q_OBJECT
public:
	StructModule(QTextEdit* outputEditBox);
	~StructModule();
	void init(bool isVisual);
	
	sieObject* addObject(const char* name,int type,int par1=-1,int par2=-1,int par3=-1,int par4=-1);
	void setCoordinates(const char* name,int x,int y);
	sieObject* find(const char* name);
	void setConnection(sieObject* obj1,sieObject* obj2,int type=-1,int probability=-1);
	bool setConnection(const char* obj1name,const char* obj2name,int type=-1,int probability=-1);
	QString getStatistic();

	void start(int modelSpeed,int lf=-1);
	void setLife(int life) {modelLife=life;}
	int life() {return modelLife;}
//	void save(const char* filename);
	std::vector<sieObject*> objects() {return items;}
signals:
	void signalComplete();
public slots:
	void tic();
	void stop();

	void slotGeneratorEmpty();
	void slotDecLife();
	
private:
	std::vector<sieObject*> items;
	std::vector<sieObject*>::iterator current;
	QTimer* systemTimer;
	int modelLife;
	int modelLifeInit;
	int currentTime;
	
	int workGeneratorNum;
	int workGeneratorNumInit;
	
	QTextEdit* output;
	sieTransactList* transactList;
};

//----------------------------------------------------------

#endif
